//-----------------------------------------------------------
//
//-----------------------------------------------------------
class Logger extends Actor;

var Controller myController;

var FileLog LogFile;
var FileLog LogFileSecond;

// how often to log player position in miliseconds
var config float logDelta;
var float lastLogTime;
var string FileName;

function InitLog()
{
	LogFile = Spawn(class'Engine.FileLog',self);
	LogFileSecond = Spawn(class'Engine.FileLog',self);
	FileName = Level.Year$"-"$Level.Month$"-"$Level.Day$"_"$Level.Hour$"-"$Level.Minute$"-"$Level.Second$"-TrackerFor"$myController$myController.PlayerReplicationInfo.PlayerID;
	LogFile.OpenLog(FileName);
	LogFile.logf("Logging started:"$Level.Year$"/"$Level.Month$"/"$Level.Day$"_"$Level.Hour$":"$Level.Minute$":"$Level.Second$"."$Level.MilliSecond);
	LogFile.logf("Logging period: "$logDelta$" ms.");
	LogFile.logf("//---------------------------------------------------");
	lastLogTime = 0;
	LogFile.CloseLog();

}

function LogKey(string key)
{
	LogFile.OpenLog(FileName);
	LogFile.LogF("KeyPressed:"$Key$". Time:"$Level.Year$"/"$Level.Month$"/"$Level.Day$"_"$Level.Hour$":"$Level.Minute$":"$Level.Second$"."$Level.MilliSecond);
	LogFile.CloseLog();
}
	/*
function UpdateLog()
{

	local rotator myRotation;

 	if (LogFile == none)
		return;

	if ( (lastLogTime == 0) || (((Level.Second * 1000 + Level.Millisecond) - lastLogTime) > logDelta) )
	{
		if (myController.Pawn == none)
		{
			if (!bPawnWasNone)
			{
			  	LogFile.LogF("Pawn none at time:"$Level.Year$"/"$Level.Month$"/"$Level.Day$"_"$Level.Hour$":"$Level.Minute$":"$Level.Second$"."$Level.MilliSecond);
			  	bPawnWasNone = true;
			}
		}
		else
		{
			if (bPawnWasNone)
			{
				LogFile.LogF("Pawn reappeared at time:"$Level.Year$"/"$Level.Month$"/"$Level.Day$"_"$Level.Hour$":"$Level.Minute$":"$Level.Second$"."$Level.MilliSecond);
				bPawnWasNone = false;
			}
			myRotation =  myController.Pawn.Rotation;
			myRotation.Pitch = int(myController.Pawn.ViewPitch) * 65556/255;
		  	LogFile.LogF("Time:"$Level.Hour$":"$Level.Minute$":"$Level.Second$"."$Level.MilliSecond$" Location:"$myController.Pawn.Location$" Rotation:"$myRotation);
		}
		lastLogTime = Level.Second * 1000 + Level.Millisecond;
	}

	if (myController == none)
	{
		LogFile.Logf("Logging ended (a). Time:"$Level.Year$"/"$Level.Month$"/"$Level.Day$"_"$Level.Hour$":"$Level.Minute$":"$Level.Second$"."$Level.MilliSecond);
		LogFile.CloseLog();
		Level.Game.ConsoleCommand("flush", True);
	}
}  */

event Destroyed()
{
	LogFile.OpenLog(FileName);
	LogFile.Logf("Logging ended (d). Time:"$Level.Year$"/"$Level.Month$"/"$Level.Day$"_"$Level.Hour$":"$Level.Minute$":"$Level.Second$"."$Level.MilliSecond);
	LogFile.CloseLog();
	Level.Game.ConsoleCommand("flush", True);
}

DefaultProperties
{
	logDelta = 100
}
