class TrackerHUD extends HudBase
	config(Track);

var float shift;
var bool bDrawInfo;

var Logger Logger;

var array<vector> PlayerPosList;
var array<string> PlayerRotList;
var array<string> Time;


function PostRender(Canvas C)
{
	SetFont(C);
	//C.DrawText("TEST: ",true);
	GetPositions(C);

}

function GetPositions(canvas C)
{
	local vector PlayerLocation;
	local rotator myRotation;
	local string PlayerRotation;
	local float ScreenLocX, ScreenLocY, currentTime;
	local bool hasPawn;
	local int j;

	if (PlayerOwner.Pawn != none)
	{
		PlayerLocation = PlayerOwner.Pawn.Location;
		myRotation = PlayerOwner.Pawn.Rotation;
		myRotation.Pitch = int(PlayerOwner.Pawn.ViewPitch) * 65556/255;
		PlayerRotation = string(myRotation);
		hasPawn = true;
	}
	else if (PlayerOwner.ViewTarget != none)
	{
		PlayerLocation = PlayerOwner.ViewTarget.Location;
		PlayerRotation = string(PlayerOwner.Rotation);
		hasPawn = false;
	}
	else
	{
		PlayerLocation = PlayerOwner.Location;
		PlayerRotation = string(PlayerOwner.Rotation);
		hasPawn = false;
	}

	if (bDrawInfo) //we will draw just if user wants us to
	{
		SetFont(C);
		ScreenLocX = 40;
		ScreenLocY = 40;
		C.SetPos(ScreenLocX, ScreenLocY);
		C.DrawText("My Location: "$PlayerLocation,true);
   		ScreenLocY += shift;
		C.SetPos(ScreenLocX, ScreenLocY);
		C.DrawText("My Rotation: "$PlayerRotation,true);
	}

	currentTime = Level.Second * 1000 + Level.Millisecond + 60000 * Level.Minute + 3600000 * Level.Hour;
	if ( (Logger.lastLogTime == 0) || ((currentTime - Logger.lastLogTime) > Logger.logDelta) )
	{
		Logger.lastLogTime = currentTime;

		j = Time.Length;
		Time[j] = Level.Hour$":"$Level.Minute$":"$Level.Second$"."$Level.MilliSecond;
		if (!hasPawn)
			Time[j] = "(Pawn None)" $ Time[j];
		PlayerPosList[PlayerPosList.Length] = PlayerLocation;
		PlayerRotList[PlayerRotList.Length] = PlayerRotation;

		if (Time.Length > 100)
			WriteToLog();

	}

}

function WriteToLog()
{
	local int i;
    Logger.LogFileSecond.OpenLog(Logger.FileName$"_Pos");
	for (i=0;i<PlayerPosList.Length;i++)
	{
		Logger.LogFileSecond.Logf(Time[i]$" Loc:"$PlayerPosList[i]$" Rot:"$PlayerRotList[i]);
	}
	Logger.LogFileSecond.CloseLog();


	Time.Length = 0;
	PlayerPosList.Length = 0;
	PlayerRotList.Length = 0;
}

event Destroyed()
{
	WriteToLog();
}

function SetFont(Canvas C)
{
	C.DrawColor = class'Canvas'.Static.MakeColor(0,155,55);


    if (C.SizeX <= 800)
	{
		shift = 15;
		C.Font = C.SmallFont;
		C.FontScaleX=1;
		C.FontScaleY=1;
	}
	else
	{
		shift = 25;
		C.Font = C.MedFont;
		C.FontScaleX=1;
		C.FontScaleY=1;
	}

}

defaultproperties
{
	bDrawInfo=False
}

