class TrackerMutator extends Mutator
	config(Track);

var bool bAffectSpectators; // If this is set to true, an interaction will be created for spectators
var bool bAffectPlayers; // If this is set to true, an interaction will be created for players
var bool bHasInteraction;

function PreBeginPlay()
{

    log("Tracker Mutator Started"); // Always comment out your logs unless they're errors

}

event Destroyed()
{

}

simulated function Tick(float DeltaTime)
{
	local PlayerController PC;

    PC = Level.GetLocalPlayerController();

    // If the player has an interaction already, exit function.
    if (bHasInteraction)
        Return;

    // Run a check to see whether this mutator should create an interaction for the player
    if ( PC != None && ((PC.PlayerReplicationInfo.bIsSpectator && bAffectSpectators) || (bAffectPlayers && !PC.PlayerReplicationInfo.bIsSpectator)) )
    {
        PC.Player.InteractionMaster.AddInteraction("Track.TrackerInteraction", PC.Player); // Create the interaction
        bHasInteraction = True; // Set the variable so this lot isn't called again
    }
    Disable('Tick');
}

function Mutate(string MutateString, PlayerController Sender)
{
	log("We are in mutate");
	super.Mutate(MutateString, Sender);
}

function ServerTraveling(string URL, bool bItems)
{
	bHasInteraction = false;
    Enable('Tick');
	super.ServerTraveling(URL,bItems);
}

DefaultProperties
{
     bAffectSpectators=true
     bAffectPlayers=true
     RemoteRole=ROLE_SimulatedProxy
     bAlwaysRelevant=true
 }
